/*
    SNU 4541.664A HW4 
*/

%{
 
%}
  
%token IF THEN ELSE WHILE IN END DO READINT SKIP STAR AMPER MALLOC
%token PLUS MINUS LP RP COLONEQ EQUAL LT SEMICOLON LAND EOF 
%token <int> NUM 
%token <string> ID

%token UMINUS

%left SEMICOLON             
%right COLONEQ             
%nonassoc IF THEN ELSE
%left LAND
%left EQUAL 
%left LT
%left PLUS 
%right MINUS
%nonassoc NUM ID READINT LP STAR

%start program
%type <Syn.cmd> program
%type <Syn.exp> expr

%%
program: cmd EOF   {$1}
     ;   

cmd : ID COLONEQ expr                   {Syn.VarAssign($1,$3)}
    | STAR ID COLONEQ expr              {Syn.DerefAssign($2,$4)}
    | cmd SEMICOLON cmd                 {Syn.Seq ($1,$3)}
    | IF bexpr THEN cmd ELSE cmd END     {Syn.If($2,$4,$6)}
    | WHILE bexpr DO cmd END             {Syn.While($2,$4)}
    | SKIP                              {Syn.Skip}


expr: LP expr RP   {$2}
    | NUM           {Syn.Num($1)}
    | ID            {Syn.Var($1)}
    | STAR ID       {Syn.Deref($2)}
    | AMPER ID      {Syn.AddrOf($2)}
    | READINT       {Syn.ReadInt}
    | MINUS expr    {Syn.Unop(Syn.UMinus,$2)}
    | expr PLUS expr    {Syn.Bnop(Syn.Add,$1,$3)}
    | MALLOC expr   {Syn.Malloc($2)}

bexpr: LP bexpr RP      {$2}
    | expr LT expr      {Syn.Blop(Syn.Lt,$1,$3)}
    | bexpr LAND bexpr    {Syn.Land($1,$3)}
    | expr EQUAL   expr    {Syn.Blop(Syn.Eq,$1,$3)}


%%

